#!/usr/bin/perl -w

use strict;


### VARIABLES ###

my $seqprob;           #se li associa el nom del fitxer amb seqncia problema
my $out;               #se li associa el nom del fitxer de sortida
my $ref;               #llegeix la referncia de la seqncia en fasta
my @fasta;             #llegeix les altres linies de la seqncia en fasta
my $fastap;            #posici del vector @fasta
my $seq;               #cont la seqncia llegida a @fasta sense salts de lnia
my $seq1;              #seqncia en la segona pauta de lectura
my $seq2;              #seqncia en la tercera pauta de lectura
my $seq3;              #seqncia en la quarta pauta de lectura
my $seq4;              #seqncia en la cinquena pauta de lectura
my $seq5;              #seqncia en la sisena pauta de lectura
my $long;              #llargada mnima del vector
my $complem;           #si es t en compte la cadena complementaria
my @orf1;              #cont tots els orf pel primer marc de lectura
my @orf2;              #cont tots els orf pel segon marc de lectura
my @orf3;              #cont tots els orf pel tercer marc de lectura
my @orf4;              #cont tots els orf pel quart marc de lectura
my @orf5;              #cont tots els orf pel cinqu marc de lectura
my @orf6;              #cont tots els orf pel sis marc de lectura
my @seqv;              #@seqv cont $seq cod a cod; $inici cont el cod d'inici de l'orf
my (@orftot,@atgPos, @stopPos);  #@orftot conte tots els orf d'una seqncia; @atgPos cont la posici on comena cada orf
my ($orftot,$atgPos, $stopPos);
my @tradv;             #@tradv conte els orf traduts
my $tradv;
my $longseq;           #longitud de la seqncia
my $inici;             #guarda la opci que l'orf comenci o no amb Met
my $char;              #carcters per lnia a l'imprimir els orf
my %aminoacid=("TTT" => "F",  #cont la relaci cod-aminocid (codi d'una lletra)
"TTC" => "F",
"TTA" => "L",
"TTG" => "L",
"CTT" => "L",
"CTC" => "L",
"CTA" => "L",
"CTG" => "L",
"ATT" => "I",
"ATC" => "I",
"ATA" => "I",
"ATG" => "M",
"GTT" => "V",
"GTC" => "V",
"GTA" => "V",
"GTG" => "V",
"TCT" => "S",
"TCC" => "S",
"TCA" => "S",
"TCG" => "S",
"CCT" => "P",
"CCC" => "P",
"CCA" => "P",
"CCG" => "P",
"ACT" => "T",
"ACC" => "T",
"ACA" => "T",
"ACG" => "T",
"GCT" => "A",
"GCC" => "A",
"GCA" => "A",
"GCG" => "A",
"TAT" => "Y",
"TAC" => "Y",
"TAA" => "*",
"TAG" => "*",
"CAT" => "H",
"CAC" => "H",
"CAA" => "Q",
"CAG" => "Q",
"AAT" => "N",
"AAC" => "N",
"AAA" => "K",
"AAG" => "K",
"GAT" => "D",
"GAC" => "D",
"GAA" => "E",
"GAG" => "E",
"TGT" => "C",
"TGC" => "C",
"TGA" => "*",
"TGG" => "W",
"CGT" => "R",
"CGC" => "R",
"CGA" => "R",
"CGG" => "R",
"AGT" => "S",
"AGC" => "S",
"AGA" => "R",
"AGG" => "R",
"GGT" => "G",
"GGC" => "G",
"GGA" => "G",
"GGG" => "G");


### FUNCIONS ####

#busca els orf que comencen per ATG dins una seqncia
#rep la seqncia ("seqv)
#retorna el vector que cont els orf i els que conten les posicions d'inici i final de de cada orf
sub orfExtract
{
    my $gravar=0;               #variable que determina si es grava (=1) o no (=0) el vector
    my ($args) = @_;            #cont els arguments que se li passen a la funci
    my @args = @$args;
    my @seqv=@args;             #cont la seqncia a analitzar
    my $k=0;                    #posici del vector @orftot
    my $x=0;                    #posici del vector @seqv
    my $i=0;                    #posici del vector @atgPos
    my $j=0;                    #posici del vector @orf
    my $l=0;                    #posici del vector @stopPos
    my @orf=();                 #cont un orf
    my @orftot = ();            #cont el conjunt d'orf d'una pauta de lectura
    my @atgPos =();             #cont la posici d'inici de cada orf
    my @stopPos = ();           #cont la posici de final de cada orf
    
    for($x = 0; $x < scalar(@seqv); $x++)    #recorre la seqncia cod a cod
    {
	
	if ($seqv [$x] eq 'ATG')             #si el cod s ATG (Met, inici)
	{
	    
	    if ($gravar == 0)                #i si $gravar s =0 (per tant, no es t un compte un ATG a meitat de l'orf)
	    {
		$atgPos[$i] = ($x+1)*3-2;    #grava la posici d'inici de l'orf
		$i++;                        #avana una posici a @atgPos
		$gravar = 1;                 #iguala $gravar a 1
		$j = 0;
		@orf = ();                   #buida el vector orf
	    }
	
	}
	
	if ( ($seqv[$x] eq ('TAA') || $seqv[$x] eq ('TAG') || $seqv[$x] eq ('TGA')) && ($gravar == 1))    #si el cod llegit s TAA, TAG o ATG (stop) i $gravar s 1
	{ 
	    $orf[$j] = $seqv[$x];            #copia la posici al vector orf
	    $stopPos[$l] = ($x+1)*3;         #grava la posici de final de l'orf
	    $l++;                            #avana una posici a @stopPos
	    $gravar = 0;                     #iguala $gravar a 0
	    
	    if( scalar(@orf) >= $long)       #si la longitus de @orf s major que $long
	    {
		$orftot[$k] = [@orf];        #grava el vector @orf a la posici pertinent del vector @orftotal
		$k++; 
	    }	    
	    else                             #si la longitus de @orf s menor que $long 
	    {  
		pop(@atgPos);                #elimina la darrera posici del vector @atgPos
		$i--;                        #tira el comptador enrera una posici
		pop(@stopPos);               #elimina la darrera posici del vector @stopPos
		$l--;                        #tira el comptador enrera una posici
	    } 
	
	} 
	
	if($gravar == 1)                     #si el valor de $gravar s 1
	{
	    $orf[$j] = $seqv [$x];           #va copiant les posicions de $seqv al vector @orf
	    $j++;
	}
 
    } 
    
    if ($gravar == 1)                        #si $gravar s 1, s a dir, s'ha trobat una Met per no un Stop
    {
	pop(@atgPos);                        #elimina la darrera posici del vector @atgPos
	$i--;                                #tira el comptador enrera una posici	
    }
    return (\@{orftot},\@atgPos,\@stopPos);  #retorna el valors @orftot, @atgPos i @stopPos

}


#busca els orf sense que comencin per ATG (s a dir, d'inici a Stop o d'Stop a Stop) dins una seqncia
#rep la seqncia ("seqv)
#retorna el vector que cont els orf i els que conten les posicions d'inici i final de de cada orf
sub orfExtractNoATG
{

 my ($args, $pauta) = @_;               #cont els arguments que se li passen a la funci
    my @args = @$args;
    my @seqv=@args;             #cont la seqncia a analitzar
    my $x=0;                    #posici del vector @seqv
    my $i=0;                    #posici del vector @atgPos
    my $j=0;                    #posici del vector @orf
    my $l=0;                    #posici del vector @stopPos
    my $c=1;                    #comptado pel salt de lnia
    my @orf=();                 #cont un orf
    my $atgPos;                 #cont la posici d'inici de cada orf
    my $stopPos;                #cont la posici de final de cada orf

    $atgPos = 1;                             #grava la posici de la primera 'a' de 'atg' en la seqncia
    $i++;                                    #avana una posici a @atgPos

    for($x = 0; $x < scalar(@seqv); $x++)    #recorre la seqncia cod a cod
    {
        $orf[$j] = $aminoacid{$seqv[$x]};    #va copiant les posicions de $seqv al vector @orf
        $j++;
       
	if ($seqv[$x] eq ('TAA') || $seqv[$x] eq ('TAG') || $seqv[$x] eq ('TGA'))   #si el cod llegit s TAA, TAG o TGA (stop)     
        {
	    if (scalar (@orf) >= $long)      #si l'orf t la longitud mnima
	    {
		$stopPos = ($x+1)*3;         #grava la posici de final de l'orf 

		print OUT "$ref$pauta$atgPos-$stopPos\n";   #imprimeix en fitxer la referncia completa
		$c = 1;
            
		for ($i=0; $i< scalar (@orf);$i++)           #mentre $j=0 i fins que finalitzi el vector @tradv
		{
		    print OUT "$orf[$i]";    #imprimeix en fitxer la seqncia d'aminocids
		    
		    if ($c % $char == 0 )    #si $c s mltiple de 80
		    {
			print OUT "\n";      #salt de lnia
		    }
		    
		    $c++;
		}
		print OUT "\n\n";            #salt de lnia doble
	    }

	    @orf=();                         #buida el vector @orf per gravar-hi el segent orf
	    $j = 0;                          #j torna a ser la priemra posici del vector
	    $atgPos = ($x+1+1)*3-2;          #grava la posici d'inici de l'orf	    
            
        }

    }

}


# tradueix la seqncia de DNA a protena
# rep el vector de vectors que cont tots els orf ("orftot")
# retorna un vector de vectors amb els orf traduts (@tradv)
sub traduccio
{
    my ($orfv) = @_;            #cont els arguments que se li passen a la funci
    my @orfv = @$orfv;
    my @tradv = ();             #vector que cont tots els orf traduts
    my @trad = ();              #vector on s'emmagatzema cada orf mentre es tradueix
    my $i=0;                    #cont les posicions de la primera dimensi del vector @orfv
    my $j=0;                    #cont les posicions de la segona dimensi del vector @orfv
    
    for $i ( 0 .. $#orfv )                   #mentre $i=0 i fins que finalitzi el vector @orfv
	{
	    @trad = ();                      #iguala el vector #@trad a 0

	    for $j ( 0 .. $#{$orfv[$i]} )                #mentre $j=0 i fins que finalitzi el vector @orfVec
	    {
		$trad[$j] = $aminoacid{$orfv[$i][$j]};   #aplica el hash a cada cod  de @orfv i el guarda a @trad
	    }
	    
	    $tradv[$i] = [@trad];            #grava el vector @trad al vector de vectors @tradv

	}

    return \@{tradv};                        #retorna @tradv

}


#imprimeix els orf, incloent la referncia, la pauta de lectura i la posici del cod d'inici
#rep el vector amb l'orf tradut (tradv), els vectors amb la posicions d'inici i final de l'orf (@atgPos i @stopPos) i la pauta de lectura
sub mostrar
{
    my ($tradv,$atgPos,$stopPos,$pauta) = @_;  #cont els arguments que se li passen a la funci
    my @atgPos = @$atgPos;
    my @stopPos = @$stopPos; 
    my @tradv = @$tradv;              
    my $i=0;                          #cont les posicions de la segona dimensi del vector @atgPos
    my $l=0;                          #cont les posicions de la segona dimensi del vector @stopPos
    my $j=0;                          #cont les posicions de la primera dimensi del vector @orfv
    my $c=1;                          #comptador pel salt de lnia
	
    for $i ( 0 .. $#tradv )                   #mentre $i=0 i fins que finalitzi el vector @tradv
    {
	print OUT "$ref$pauta $atgPos[$i]-$stopPos[$l]\n"; #imprimeix en fitxer la referncia completa
	$l++;
	$c = 1;
	
	for $j ( 0 .. $#{$tradv[$i]} )        #mentre $j=0 i fins que finalitzi el vector @tradv
	{

	    print OUT $tradv[$i][$j] ;        #imprimeix en fitxer la seqncia d'aminocids
	    if ($c % $char == 0 )                #si $c s mltiple de 80
	    {
		print OUT "\n";               #salt de lnia
	    }
	    $c++;
	}

	print OUT "\n\n";                     #salt de lnia doble

    }
	
}

#ajusta les posicions, ja que les posicions preses considera el primer nucletid de la pauta com el primer de la seqncia. Tambe fa la correccio per la cadena complementaria
#rep els vectors amb les posicions d'inici i final, el corrector especfic de pauta ($num) i la opci de cadena complementaria ($comp)
#retorna  els vectors amb les posicions d'inici i final, ja modificats
sub AjustaPos
{
    my ($atgPos,$stopPos,$num,$comp) = @_;  #cont els arguments que se li passen a la funci#
    my @atgPos = @$atgPos;
    my @stopPos = @$stopPos;               
    my $i=0;                          #cont les posicions de la segona dimensi del vector @atgPos

    #print  scalar(@atgPos). " \n";
    #print  scalar(@stopPos). " \n";
    for $i ( 0 .. $#atgPos )
    {

	if ($comp eq 'y')
	{
	    $atgPos[$i] = $longseq - $atgPos[$i] + $num;
	    $stopPos[$i] = $longseq - $stopPos[$i] + $num;
	}
	else
	{
	    $atgPos[$i] = $atgPos[$i] + $num;
	    $stopPos[$i] = $stopPos[$i] + $num;
	}
    }
    
    return (\@atgPos,\@stopPos);
}


### COS PRINCIPAL DEL PROGRAMA ###

#presentaci

print "\n\t#########################################################\n";
print "\t#                                                       #\n";
print "\t#                                                       #\n";
print "\t#                                                       #\n";
print "\t#                      FINDORF 2003                     #\n";
print "\t#                                                       #\n";
print "\t#                       versi 1.0                      #\n";
print "\t#                                                       #\n";
print "\t#                                                       #\n";
print "\t#          Ramrez-Soriano A - Molina-Toms MC          #\n";
print "\t#                                                       #\n";
print "\t#                                                       #\n";
print "\t#                                                       #\n";
print "\t#########################################################\n\n";


#introduir el nom del fitxer de la seqncia problema
 
print "introduce the name of the file containing the sequence where you desire to find orf:\n"; 

$seqprob = <STDIN>; 

chomp ($seqprob); 


#introduir el nom del fitxer de sortida 

print "introduce the name of the outfile :\n";

$out = <STDIN>; 

chomp ($out);


#definir cod d'inici

print "do you desire that the orf starts with Met? (y/n):\n";

$inici = <STDIN>;

chomp ($inici);


#fixar una llargada mnima de l'orf

print "enter the minimum number of codons for an orf to be considered significant:\n";
 
$long = <STDIN>;


#tenir o no en compte la cadena complementaria

print "do you desire to search orf also in complementary chain? (y/n):\n";

$complem = <STDIN>;

chomp ($complem);


#carcters per lnia en fasta

print "how many aminoacids do you desire to print for each line of the orf sequence?\n";

$char = <STDIN>;

chomp ($char);


#obrir el fitxer amb la seqncia problema i associar-la a la variable $seq

open(FITXER,"<$seqprob") || die "no es pot obrir fitxer d'entrada\n";


#obrir el fitxer amb la seqncia problema

$ref = <FITXER>;        #llegeix la referncia del fitxer (lnia 1)
chomp($ref);
 
@fasta = <FITXER>;      #llegeix la resta de lnies del fitxer 

$seq = "";              #s'associa la variable a paraula buida 


#obt el contingut de la seqncia en fasta (ja se li eliminat la referncia) en una sola lnia

foreach $fastap (@fasta)        #per cada posici del vector @fasta 
{ 
    chomp($fastap );            #elimina el salt de lnia 
    $seq = $seq . $fastap;      #concatena una lnia al contingut de la variable seqncia
}

 
close(FITXER);                  #tancar el fitxer

$longseq = length($seq);

$seq = "\U$seq";                #passar totes les bases a majuscules 

$seq1 = substr($seq,1);         #elimina la primera posici de seq, obtenint la segona pauta de lectura

$seq2 = substr($seq,2);         #elimina les dues primeres posicions de seq, obtenint la tercera pauta de lectura




open(OUT, ">$out") || die "no es pot obrir el fitxer de sortida\n";    #obrir el fitxer de sortida


#busca els orf en cada pauta de lectura

@seqv = ($seq =~ m/.../g);                                 #guarda $seq al vector @seqv cod a cod
if($inici eq 'y')                                          #si volem que la seqncia comenci amb ATG
{
    ($orftot,$atgPos,$stopPos) = &orfExtract(\@{seqv});    #crida a la funci orfExtract, que extreu els orf
    @orftot = @$orftot;
    @atgPos = @$atgPos;
    @stopPos = @$stopPos;
    $tradv = &traduccio(\@{orftot});                       #crida a la funci traduccio, que tradueix a protena
    @tradv = @$tradv;
    &mostrar((\@{tradv},\@atgPos,\@stopPos,''));           #crida a la funci mostrar, que imprimeix els resultats en format fasta
}
else                                                       #si no
{
    &orfExtractNoATG ((\@{seqv}), '');                     #crida a la funci orfExtractNoATG, que executa tot el procs d'extracci i mostrat dels orf
}

@seqv = ($seq1 =~ m/.../g);
if($inici eq 'y')
{
    ($orftot,$atgPos,$stopPos) = &orfExtract(\@{seqv});
    @orftot = @$orftot;
    @atgPos = @$atgPos;
    @stopPos = @$stopPos;
    ($atgPos,$stopPos) = &AjustaPos(\@atgPos,\@stopPos,1,'n');    #crida la funci AjustaPos, que ajusta la posici segons la pauta
    @atgPos = @$atgPos;
    @stopPos = @$stopPos;
    $tradv = &traduccio(\@{orftot});
    @tradv = @$tradv;
    &mostrar((\@{tradv},\@atgPos,\@stopPos,''));
}
else
{
    &orfExtractNoATG ((\@{seqv}), '');
}

@seqv = ($seq2 =~ m/.../g);
if($inici eq 'y')
{
    ($orftot,$atgPos,$stopPos) = &orfExtract(\@{seqv});
    @orftot = @$orftot;
    @atgPos = @$atgPos;
    @stopPos = @$stopPos;
    ($atgPos,$stopPos) = &AjustaPos(\@atgPos,\@stopPos, 2,'n');
    @stopPos = @$stopPos;
    @atgPos = @$atgPos;
    $tradv = &traduccio(\@{orftot});
    @tradv = @$tradv;
    &mostrar((\@{tradv},\@atgPos,\@stopPos,''));
    @orf3 = @tradv;
}
else
{
    &orfExtractNoATG ((\@{seqv}), '');
}

if ($complem eq 'y')
{
    $seq3 = reverse($seq);               #gira la seqncia
    $seq3 =~ tr/acgtACGT/tgcaTGCA/;      #fa el complementari de la seqncia revertida: quarta pauta de lectura

    $seq4 = substr($seq3,1);             #elimina la primera posici de seq3, obtenint la cinquena pauta de lectura

    $seq5 = substr($seq3,2);             #elimina les dues primeres posicions de seq3, obtenint la sisena pauta de lectura


    @seqv = ($seq3 =~ m/.../g);
    if($inici eq 'y')
    {
	($orftot,$atgPos,$stopPos) = &orfExtract(\@{seqv});
	@orftot = @$orftot;
	@atgPos = @$atgPos;
	@stopPos = @$stopPos;
	($atgPos,$stopPos) = &AjustaPos(\@atgPos,\@stopPos, 1,'y');
	@stopPos = @$stopPos;
	@atgPos = @$atgPos;
	$tradv = &traduccio(\@{orftot});
	@tradv = @$tradv;
	&mostrar((\@{tradv},\@atgPos,\@stopPos,'complem'));
	@orf4 = @tradv;
    }
    else
    { 
	&orfExtractNoATG ((\@{seqv}), 'complem');
    }
	
    @seqv = ($seq4 =~ m/.../g);
    if($inici eq 'y')
    {
	($orftot,$atgPos,$stopPos) = &orfExtract(\@{seqv});
	@orftot = @$orftot;
	@atgPos = @$atgPos;
	@stopPos = @$stopPos;
	($atgPos,$stopPos) = &AjustaPos(\@atgPos,\@stopPos, 0,'y');
	@stopPos = @$stopPos;
	@atgPos = @$atgPos;
	$tradv = &traduccio(\@{orftot});
	@tradv = @$tradv;
	&mostrar((\@{tradv},\@atgPos,\@stopPos,'complem'));
	@orf5 = @tradv;
    }
    else
    {
	&orfExtractNoATG ((\@{seqv}), 'complem');
    }

    @seqv = ($seq5 =~ m/.../g);
    if($inici eq 'y')
    {
	($orftot,$atgPos,$stopPos) = &orfExtract(\@{seqv});
	@orftot = @$orftot;
	@atgPos = @$atgPos;
	@stopPos = @$stopPos;
	($atgPos,$stopPos) = &AjustaPos(\@atgPos,\@stopPos, -1,'y');
	@stopPos = @$stopPos;
	@atgPos = @$atgPos;
	$tradv = &traduccio(\@{orftot});
	@tradv = @$tradv;
	&mostrar((\@{tradv},\@atgPos,\@stopPos,'complem'));
	@orf6 = @tradv;
    }
    else
    {
	&orfExtractNoATG ((\@{seqv}), 'complem');
    }
}

close(OUT);
